DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Member Functions | Private Attributes | Friends | List of all members
DSRWaveformReferenceValue Class Reference

Class for waveform reference values. More...

Inheritance diagram for DSRWaveformReferenceValue:

## Public Member Functions
| DSRWaveformReferenceValue ()
| default constructor
| DSRWaveformReferenceValue (const OFString &sopClassUID, const OFString &sopInstanceUID, const OFBool check=OFTrue)
| constructor More...
| DSRWaveformReferenceValue (const DSRWaveformReferenceValue &referenceValue)
| copy constructor More...
virtual | ~DSRWaveformReferenceValue ()
| destructor
DSRWaveformReferenceValue & | operator= (const DSRWaveformReferenceValue &referenceValue)
| assignment operator More...
virtual void | clear ()
| clear all internal variables. More...
OFBool | isEqual (const DSRWaveformReferenceValue &referenceValue) const
| check whether values are "equal" More...
OFBool | isNotEqual (const DSRWaveformReferenceValue &referenceValue) const
| check whether values are "not equal" More...
virtual OFBool | isShort (const size_t flags) const
| check whether the content is short. More...
virtual OFCondition | print (STD_NAMESPACE ostream &stream, const size_t flags) const
| print waveform reference. More...
virtual OFCondition | readXML (const DSRXMLDocument &doc, DSRXMLCursor cursor, const size_t flags)
| read waveform reference from XML document More...
virtual OFCondition | writeXML (STD_NAMESPACE ostream &stream, const size_t flags) const
| write waveform reference in XML format More...
virtual OFCondition | renderHTML (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &annexStream, size_t &annexNumber, const size_t flags, const char *urlPrefix=NULL) const
| render waveform reference value in HTML/XHTML format More...
const DSRWaveformReferenceValue & | getValue () const
| get reference to waveform reference value More...
OFCondition | getValue (DSRWaveformReferenceValue &referenceValue) const
| get copy of waveform reference value More...
OFCondition | setValue (const DSRWaveformReferenceValue &referenceValue, const OFBool check=OFTrue)
| set waveform reference value. More...
DSRWaveformChannelList & | getChannelList ()
| get reference to list of referenced waveform channels More...
OFBool | appliesToChannel (const Uint16 multiplexGroupNumber, const Uint16 channelNumber) const
| check whether the waveform reference applies to a specific channel. More...
Public Member Functions inherited from DSRCompositeReferenceValue
| DSRCompositeReferenceValue ()
| default constructor
| DSRCompositeReferenceValue (const OFString &sopClassUID, const OFString &sopInstanceUID, const OFBool check=OFTrue)
| constructor More...
| DSRCompositeReferenceValue (const DSRCompositeReferenceValue &referenceValue)
| copy constructor More...
virtual | ~DSRCompositeReferenceValue ()
| destructor
DSRCompositeReferenceValue & | operator= (const DSRCompositeReferenceValue &referenceValue)
| assignment operator More...
OFBool | isEqual (const DSRCompositeReferenceValue &referenceValue) const
| check whether values are "equal" More...
OFBool | isNotEqual (const DSRCompositeReferenceValue &referenceValue) const
| check whether values are "not equal" More...
virtual OFBool | isValid () const
| check whether the current reference value is valid. More...
virtual OFBool | isEmpty () const
| check whether the current reference value is empty. More...
virtual OFBool | isComplete () const
| check whether the current reference value is complete, i.e. whether both mandatory UIDs are non-empty. More...
virtual OFCondition | readSequence (DcmItem &dataset, const DcmTagKey &tagKey, const OFString &type, const size_t flags)
| read referenced SOP sequence from dataset. More...
virtual OFCondition | writeSequence (DcmItem &dataset, const DcmTagKey &tagKey) const
| write referenced SOP sequence to dataset. More...
const OFString & | getSOPClassUID () const
| get SOP class UID More...
const OFString | getSOPClassName (const OFString &defaultName="unknown SOP Class UID") const
| get name associated with the SOP class UID (if any) More...
const OFString & | getSOPInstanceUID () const
| get SOP instance UID More...
const DSRCompositeReferenceValue & | getValue () const
| get reference to composite reference value More...
OFCondition | getValue (DSRCompositeReferenceValue &referenceValue) const
| get copy of composite reference value More...
OFCondition | setValue (const DSRCompositeReferenceValue &referenceValue, const OFBool check=OFTrue)
| set composite reference value. More...
OFCondition | setReference (const OFString &sopClassUID, const OFString &sopInstanceUID, const OFBool check=OFTrue)
| set SOP class UID and SOP instance UID value. More...
OFCondition | setReference (DcmItem &dataset, const OFBool check=OFTrue)
| set SOP class UID and SOP instance UID value from dataset. More...
OFCondition | setSOPClassUID (const OFString &sopClassUID, const OFBool check=OFTrue)
| set SOP class UID value. More...
OFCondition | setSOPClassUID (const DcmElement &delem, const unsigned long pos=0, const OFBool check=OFTrue)
| set SOP class UID value from element. More...
OFCondition | setSOPClassUID (DcmItem &dataset, const DcmTagKey &tagKey, const unsigned long pos=0, const OFBool check=OFTrue)
| set SOP class UID value from dataset. More...
OFCondition | setSOPInstanceUID (const OFString &sopInstanceUID, const OFBool check=OFTrue)
| set SOP instance UID value. More...
OFCondition | setSOPInstanceUID (const DcmElement &delem, const unsigned long pos=0, const OFBool check=OFTrue)
| set SOP instance UID value from element. More...
OFCondition | setSOPInstanceUID (DcmItem &dataset, const DcmTagKey &tagKey, const unsigned long pos=0, const OFBool check=OFTrue)
| set SOP instance UID value from dataset. More...

## Protected Member Functions
DSRWaveformReferenceValue * | getValuePtr ()
| get pointer to waveform reference value More...
virtual OFCondition | readItem (DcmItem &dataset, const size_t flags)
| read waveform reference value from dataset More...
virtual OFCondition | writeItem (DcmItem &dataset) const
| write waveform reference value to dataset More...
virtual OFCondition | checkSOPClassUID (const OFString &sopClassUID, const OFBool reportWarnings=OFFalse) const
| check the specified SOP class UID for validity. More...
Protected Member Functions inherited from DSRCompositeReferenceValue
DSRCompositeReferenceValue * | getValuePtr ()
| get pointer to reference value More...
virtual OFCondition | checkSOPInstanceUID (const OFString &sopInstanceUID, const OFBool reportWarnings=OFFalse) const
| check the specified SOP instance UID for validity. More...
OFCondition | checkCurrentValue (const OFBool reportWarnings=OFFalse) const
| check the currently stored reference value for validity. More...

## Private Attributes
DSRWaveformChannelList | ChannelList
| list of referenced waveform channels (associated DICOM VR=US, VM=2-2n, type 1C)

## Friends
class | DSRContentItem

## Additional Inherited Members
Protected Attributes inherited from DSRCompositeReferenceValue
OFString | SOPClassUID
| reference SOP class UID (VR=UI, type 1)
OFString | SOPInstanceUID
| reference SOP instance UID (VR=UI, type 1)

## Detailed Description

Class for waveform reference values.

## Constructor & Destructor Documentation

## ◆ DSRWaveformReferenceValue() [1/2]

DSRWaveformReferenceValue::DSRWaveformReferenceValue | ( | const OFString & | sopClassUID,
|  | const OFString & | sopInstanceUID,
|  | const OFBool | check = `OFTrue`
| ) |  |

constructor

Parameters

  sopClassUID | referenced SOP class UID of the waveform object. (VR=UI, mandatory)
  sopInstanceUID | referenced SOP instance UID of the waveform object. (VR=UI, mandatory)
  check | if enabled, check 'sopClassUID' and 'sopInstanceUID' for validity before setting them. See checkXXX() for details. Empty values are never accepted.

## ◆ DSRWaveformReferenceValue() [2/2]

DSRWaveformReferenceValue::DSRWaveformReferenceValue | ( | const DSRWaveformReferenceValue & | referenceValue | ) |

copy constructor

Parameters

  referenceValue | waveform reference value to be copied (not checked !)

## Member Function Documentation

## ◆ appliesToChannel()

OFBool DSRWaveformReferenceValue::appliesToChannel | ( | const Uint16 | multiplexGroupNumber,
|  | const Uint16 | channelNumber
| ) |  | const

check whether the waveform reference applies to a specific channel.

The waveform reference applies to a channel if the list of referenced waveform channels is empty or the group/channel pair is part of the list.

Parameters

  multiplexGroupNumber | multiplex group number of the referenced channel
  channelNumber | channel number of the referenced channel

Returns
  OFTrue if reference applies to the specified channel, OFFalse otherwise

## ◆ checkSOPClassUID()

virtual OFCondition DSRWaveformReferenceValue::checkSOPClassUID | ( | const OFString & | sopClassUID,
|  | const OFBool | reportWarnings = `OFFalse`
| ) |  | const
| protected virtual

check the specified SOP class UID for validity.

This method further specializes the checks performed in the base class DSRCompositeReferenceValue. All waveform SOP classes that are defined in DICOM PS 3.6-2023c are allowed.

Parameters

  sopClassUID | SOP class UID to be checked
  reportWarnings | if enabled, report warning messages to the logger

Returns
  status, EC_Normal if value is valid, an error code otherwise

Reimplemented from DSRCompositeReferenceValue.

## ◆ clear()

virtual void DSRWaveformReferenceValue::clear | ( |  | ) |
| virtual

clear all internal variables.

Since an empty waveform reference is invalid the reference becomes invalid afterwards.

Reimplemented from DSRCompositeReferenceValue.

Reimplemented in DSRWaveformTreeNode.

## ◆ getChannelList()

DSRWaveformChannelList& DSRWaveformReferenceValue::getChannelList | ( |  | ) |
| inline

get reference to list of referenced waveform channels

Returns
  reference to channel list

## ◆ getValue() [1/2]

const DSRWaveformReferenceValue& DSRWaveformReferenceValue::getValue | ( |  | ) | const
| inline

get reference to waveform reference value

Returns
  reference to waveform reference value

## ◆ getValue() [2/2]

OFCondition DSRWaveformReferenceValue::getValue | ( | DSRWaveformReferenceValue & | referenceValue | ) | const

get copy of waveform reference value

Parameters

  referenceValue | reference to variable in which the value should be stored

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getValuePtr()

DSRWaveformReferenceValue* DSRWaveformReferenceValue::getValuePtr | ( |  | ) |
| inline protected

get pointer to waveform reference value

Returns
  pointer to waveform reference value (never NULL)

## ◆ isEqual()

OFBool DSRWaveformReferenceValue::isEqual | ( | const DSRWaveformReferenceValue & | referenceValue | ) | const

check whether values are "equal"

Parameters

  referenceValue | waveform reference value that should be compared to the current one

Returns
  OFTrue if both waveform reference values are equal, OFFalse otherwise

## ◆ isNotEqual()

OFBool DSRWaveformReferenceValue::isNotEqual | ( | const DSRWaveformReferenceValue & | referenceValue | ) | const

check whether values are "not equal"

Parameters

  referenceValue | waveform reference value that should be compared to the current one

Returns
  OFTrue if both waveform reference values are not equal, OFFalse otherwise

## ◆ isShort()

virtual OFBool DSRWaveformReferenceValue::isShort | ( | const size_t | flags | ) | const
| virtual

check whether the content is short.

This method is used to check whether the rendered output of this content item can be expanded inline or not (used for renderHTML()).

Parameters

  flags | flag used to customize the output (see DSRTypes::HF_xxx)

Returns
  OFTrue if the content is short, OFFalse otherwise

Reimplemented in DSRWaveformTreeNode.

## ◆ operator=()

DSRWaveformReferenceValue& DSRWaveformReferenceValue::operator= | ( | const DSRWaveformReferenceValue & | referenceValue | ) |

assignment operator

Parameters

  referenceValue | waveform reference value to be copied (not checked !)

Returns
  reference to this waveform reference value after 'referenceValue' has been copied

## ◆ print()

virtual OFCondition DSRWaveformReferenceValue::print | ( | STD_NAMESPACE ostream & | stream,
|  | const size_t | flags
| ) |  | const
| virtual

print waveform reference.

The output of a typical waveform reference value looks like this: (HemodynamicWaveformStorage,"1.2.3") If the SOP class UID is unknown, the UID is printed instead of the related name.

Parameters

  stream | output stream to which the image reference value should be printed
  flags | flag used to customize the output (see DSRTypes::PF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRCompositeReferenceValue.

Reimplemented in DSRWaveformTreeNode.

## ◆ readItem()

virtual OFCondition DSRWaveformReferenceValue::readItem | ( | DcmItem & | dataset,
|  | const size_t | flags
| ) |  |
| protected virtual

read waveform reference value from dataset

Parameters

  dataset | DICOM dataset from which the value should be read
  flags | flag used to customize the reading process (see DSRTypes::RF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRCompositeReferenceValue.

## ◆ readXML()

virtual OFCondition DSRWaveformReferenceValue::readXML | ( | const DSRXMLDocument & | doc,
|  | DSRXMLCursor | cursor,
|  | const size_t | flags
| ) |  |
| virtual

read waveform reference from XML document

Parameters

  doc | document containing the XML file content
  cursor | cursor pointing to the starting node
  flags | flag used to customize the reading process (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRCompositeReferenceValue.

## ◆ renderHTML()

virtual OFCondition DSRWaveformReferenceValue::renderHTML | ( | STD_NAMESPACE ostream & | docStream,
|  | STD_NAMESPACE ostream & | annexStream,
|  | size_t & | annexNumber,
|  | const size_t | flags,
|  | const char * | urlPrefix = `NULL`
| ) |  | const
| virtual

render waveform reference value in HTML/XHTML format

Parameters

  docStream | output stream to which the main HTML/XHTML document is written
  annexStream | output stream to which the HTML/XHTML document annex is written
  annexNumber | reference to the variable where the current annex number is stored. Value is increased automatically by 1 after a new entry has been added.
  flags | flag used to customize the output (see DSRTypes::HF_xxx)
  urlPrefix | optional URL prefix used for hyperlink to referenced composite object

Note
  Please note that using parameter 'urlPrefix' can lead to security issues, as an attacker could misuse it to potentially inject dangerous content into the HTML/XHTML output. The value of this parameter is not checked. This is also true for derived classes.

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRCompositeReferenceValue.

## ◆ setValue()

OFCondition DSRWaveformReferenceValue::setValue | ( | const DSRWaveformReferenceValue & | referenceValue,
|  | const OFBool | check = `OFTrue`
| ) |  |

set waveform reference value.

Before setting the reference, it is usually checked. If the value is invalid, the current value is not replaced and remains unchanged.

Parameters

  referenceValue | value to be set
  check | if enabled, check value for validity before setting it. See checkXXX() for details. Empty values are only accepted for non-mandatory attributes.

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ writeItem()

virtual OFCondition DSRWaveformReferenceValue::writeItem | ( | DcmItem & | dataset | ) | const
| protected virtual

write waveform reference value to dataset

Parameters

  dataset | DICOM dataset to which the value should be written

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRCompositeReferenceValue.

## ◆ writeXML()

virtual OFCondition DSRWaveformReferenceValue::writeXML | ( | STD_NAMESPACE ostream & | stream,
|  | const size_t | flags
| ) |  | const
| virtual

write waveform reference in XML format

Parameters

  stream | output stream to which the XML document is written
  flags | flag used to customize the output (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRCompositeReferenceValue.

Reimplemented in DSRWaveformTreeNode.

The documentation for this class was generated from the following file:

- dcmsr/include/dcmtk/dcmsr/dsrwavvl.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1